#!/usr/bin/picolisp /usr/lib/picolisp/lib.l


(load "@lib/misc.l")

(de GetFullPath (Parent L Full)
   (cond
      ((=0 (length L)) 
         (println "=0" Full)
         (Full))                      # return Subdir list
      (T 
         #(println "****" (car L))
         (setq Full (cons (pack Parent "/" (car L)) Full))
         #(println ">>>>" Full)
         (GetFullPath Parent (cdr L) Full)) ) )


(de ffiles (Dir_list)
   # 1st time, no argument, present working directory
   (let Item (car Dir_list)

   (cond
      ((=0 (length Dir_list))
        (bye)) 

      ((nT (car (info Item))) 
         (println " ")
         (println Dir_list)
         (println (pack Item " is not a directory"))
         #(println "dirname: " (dirname Item))
         #(println "path: " (path Item))
         (PrintInfo Item) 
         (ffiles (cdr Dir_list)) )

      (T (println " ")
         (println "Dir_list: " Dir_list)
         (println (pack Item " is a directory"))
         (lst? (GetFullPath Item (dir Item)))
         (ffiles (cdr (append Dir_list (GetFullPath Item (dir Item))))) )
   ) )
)


(de PrintInfo (Item)
   (println Item  'size:  (getSize Item) 'modified: (getDateTime Item) 'path: (path Item) 'dirname: (dirname Item) 'basename: (basename Item)) )


(de getSize (Item)
   (car (info Item)))


(de getDateTime (Item)
   (stamp (cadr (info Item)) (cddr (info Item)) ) )


(de main ()
   (setq FullList ())
   (println (dir) )
   (ffiles (dir))
   (bye)
)
